#include <stdio.h>
#include <stdlib.h>
#include "lpng125-cpp/png.h"

void write_row_callback(png_structp png_ptr, png_uint_32 row, int pass){
//	printf("\r%3d%% saved", (row * 100) / png_ptr->height);
}
void write_png(char *file_name, png_bytepp image, int width, int height, int bit_depth, int color_type,
	png_color_struct *palette, int num_palette){
	FILE		*fp;
	png_structp	png_ptr;
	png_infop	info_ptr;
	void write_row_callback(png_structp png_ptr, png_uint_32 row, int pass);

	if ((fp = fopen(file_name, "wb")) == NULL) return;							  // ܂t@CJ܂
	png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);  // png_ptr\̂mہE܂
	if (png_ptr == NULL) {	// png_ptr\̂mہEs
		fclose(fp);
		return;
	}
	info_ptr = png_create_info_struct(png_ptr);			// info_ptr\̂mہE܂
	if (info_ptr == NULL) {
		printf("info_ptr\̂mہE s");
		png_destroy_write_struct(&png_ptr,	(png_infopp)NULL);		// Q̍\̂̃܂
		fclose(fp);
		return;
	}
	if (setjmp(png_ptr->jmpbuf)) {
		png_destroy_write_struct(&png_ptr,	&info_ptr);			// Q̍\̂̃܂
		fclose(fp);
		return;
	}
	png_init_io(png_ptr, fp);								// libpngfpm点܂
	png_set_write_status_fn(png_ptr, write_row_callback);
	png_set_filter(png_ptr, 0, PNG_ALL_FILTERS);
	png_set_compression_level(png_ptr, Z_BEST_COMPRESSION);
	png_set_PLTE(png_ptr, info_ptr, palette, num_palette);
	png_set_IHDR(png_ptr, info_ptr, width, height, bit_depth, color_type,	 // IHDR`Nݒ肵܂
		PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
 //	png_set_gAMA(png_ptr, info_ptr, 1.0);	//@gAMA̓JƂ̐啪ȊOł͖Ӗ

	{
		/*
		time_t		gmt;		// G.M.T.
		png_time	mod_time;
		png_text	text_ptr[5];

		time(&gmt);
		png_convert_from_time_t(&mod_time, gmt);
		png_set_tIME(png_ptr, info_ptr, &mod_time);
		
		text_ptr[0].key = "Title";
		text_ptr[0].text = "Test";
		text_ptr[0].compression = PNG_TEXT_COMPRESSION_NONE;
		text_ptr[1].key = "Author";
		text_ptr[1].text = "You";
		text_ptr[1].compression = PNG_TEXT_COMPRESSION_NONE;
		text_ptr[2].key = "Description";
		text_ptr[2].text = "Test Pattern";
		text_ptr[2].compression = PNG_TEXT_COMPRESSION_NONE;
		text_ptr[3].key = "Creation Time";
		text_ptr[3].text = png_convert_to_rfc1123(png_ptr, &mod_time);
		text_ptr[3].compression = PNG_TEXT_COMPRESSION_NONE;
		text_ptr[4].key = "Software";
		text_ptr[4].text = "test.exe";
		text_ptr[4].compression = PNG_TEXT_COMPRESSION_NONE;
		png_set_text(png_ptr, info_ptr, text_ptr, 5);
		*/
	}
	
	png_write_info(png_ptr, info_ptr);				// PNGt@C̃wb_݂܂
	png_write_image(png_ptr, image);				// 摜f[^݂܂
	png_write_end(png_ptr, info_ptr);				// c݂̏܂
	png_destroy_write_struct(&png_ptr, &info_ptr);	// Q̍\̂̃܂
	fclose(fp); 									// t@C܂
	return;
}
/*
int main(){
	// 
	FILE			*fp;
	png_structp 	png_ptr;
	png_infop		info_ptr;
	unsigned long	width, height;
	int 			bit_depth, color_type, interlace_type;
	unsigned char	**image;
	int 			i;
	
	fp = fopen("test.png", "rb");							// ܂t@CJ܂
	png_ptr = png_create_read_struct(						// png_ptr\̂mہE܂
					PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	info_ptr = png_create_info_struct(png_ptr); 			// info_ptr\̂mہE܂
	png_init_io(png_ptr, fp);								// libpngfpm点܂
	png_read_info(png_ptr, info_ptr);						// PNGt@C̃wb_ǂݍ݂܂
	png_get_IHDR(png_ptr, info_ptr, &width, &height,		// IHDR`N擾܂
					&bit_depth, &color_type, &interlace_type,
					NULL, NULL);
	image = (png_bytepp)malloc(height * sizeof(png_bytep)); // ȉRs͂Qzmۂ܂
	for (i = 0; i < height; i++)
			image[i] = (png_bytep)malloc(png_get_rowbytes(png_ptr, info_ptr));
	png_read_image(png_ptr, image); 						// 摜f[^ǂݍ݂܂
	for (i = 0; i < height; i++) free(image[i]);			// ȉQs͂Qz܂
	free(image);
	png_destroy_read_struct(								// Q̍\̂̃܂
			&png_ptr, &info_ptr, (png_infopp)NULL);
	fclose(fp); 											// t@C܂
	return 0;
}
*/

#define PNG_BYTES_TO_CHECK (4)

/*
int main(){
	// Ǎ
	FILE			*fp;
	png_structp 	png_ptr;
	png_infop		info_ptr;
	unsigned char	**image;
	unsigned long	width, height;
	png_uint_32 	i;

	// Ǎ
	check_if_png("test.png", &fp);
	read_png_info(fp, &png_ptr, &info_ptr);
	read_png_image(fp, png_ptr, info_ptr, &image, &width, &height);

		// gAMA`N擾\܂
		double			file_gamma;
		
		if (png_get_gAMA(png_ptr, info_ptr, &file_gamma))
				printf("gamma = %lf\n", file_gamma);

		// tEXt`N擾\܂
		png_textp		text_ptr;
		int 			num_text;
		if (png_get_text(png_ptr, info_ptr, &text_ptr, &num_text))
			for (i = 0; i < num_text; i++) printf("%s = %s\n", text_ptr[i].key, text_ptr[i].text);

	png_destroy_read_struct(&png_ptr, &info_ptr, (png_infopp)NULL);
	for (i = 0; i < height; i++) free(image[i]);
	free(image);
	fclose(fp);
	return 0;
}
*/

check_if_png(FILE *fp){
	char	sig[PNG_BYTES_TO_CHECK];
	if (fread(sig, 1, PNG_BYTES_TO_CHECK, fp) != PNG_BYTES_TO_CHECK) return -1;
	if (!png_check_sig(sig, PNG_BYTES_TO_CHECK)) return -1;
	return 0;
}

read_png_info(FILE *fp, png_structp *png_ptr, png_infop *info_ptr){
	*png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	if (*png_ptr == NULL) return -1;

	*info_ptr = png_create_info_struct(*png_ptr);
	if (*info_ptr == NULL) {
		png_destroy_read_struct(png_ptr, (png_infopp)NULL, (png_infopp)NULL);
		return -1;
	}
	if (setjmp((*png_ptr)->jmpbuf)) {
		png_destroy_read_struct(png_ptr, info_ptr, (png_infopp)NULL);
		return -1;
	}
	png_init_io(*png_ptr, fp);
	png_set_sig_bytes(*png_ptr, PNG_BYTES_TO_CHECK);
	png_read_info(*png_ptr, *info_ptr);
	return 0;
}

read_png_image(FILE *fp, png_structp png_ptr, png_infop info_ptr,
	png_bytepp *image, png_uint_32 *width, png_uint_32 *height){
	png_uint_32 	i, j;
	
	*width = png_get_image_width(png_ptr, info_ptr);
	*height = png_get_image_height(png_ptr, info_ptr);
	if ((*image = (png_bytepp)malloc(*height * sizeof(png_bytep))) == NULL) {
		return -1;
	}
	for (i = 0; i < *height; i++) {
		(*image)[i] = (png_bytep)malloc(png_get_rowbytes(png_ptr, info_ptr));
		if ((*image)[i] == NULL) {
			for (j = 0; j < i; j++) free((*image)[j]);
			free(*image);
			return -1;
		}
	}
	png_read_image(png_ptr, *image);
	return 0;
}
read_png_file_fp(FILE *fp, png_structp *png_ptr, png_infop *info_ptr,
	png_bytepp *image, png_uint_32 *width, png_uint_32 *height){
	if (check_if_png(fp)<0) return -1;
	if (read_png_info(fp, png_ptr, info_ptr)<0) return -1;
	if (read_png_image(fp, *png_ptr, *info_ptr, image, width, height)<0) return -1;
	return 0;
}
read_png_file(char *filename, png_structp *png_ptr, png_infop *info_ptr,
	png_bytepp *image, png_uint_32 *width, png_uint_32 *height){
	FILE *fp;
	if ((fp = fopen(filename, "rb")) == NULL) return -1;
	if (read_png_file_fp(fp, png_ptr, info_ptr, image, width, height)<0){
		fclose(fp);
		return -1;
	}
	fclose(fp);
	return 0;
}
