
//======================================
//		KEYBORD							
//======================================
class KEYBORD {
	public :
	int m_cross_code[4];
	int m_button_code[GV::GV_BUTTON_LEN];
	KEYBORD(){
		m_cross_code[GV::GV_UP]=VK_UP;
		m_cross_code[GV::GV_LEFT]=VK_LEFT;
		m_cross_code[GV::GV_DOWN]=VK_DOWN;
		m_cross_code[GV::GV_RIGHT]=VK_RIGHT;
		int i;
		for(i=0;i<GV::GV_BUTTON_LEN;i++) m_button_code[i]=0;
		m_button_code[0]='Z';
		if (GV::GV_BUTTON_LEN>1) m_button_code[1]='X';
		if (GV::GV_BUTTON_LEN>2) m_button_code[2]='C';
		if (GV::GV_BUTTON_LEN>3) m_button_code[3]='A';
		if (GV::GV_BUTTON_LEN>4) m_button_code[4]=VK_RETURN;
	}
};
/*
	VK_LBUTTON 		0x01 }EX{^ 
	VK_RBUTTON 		0x02 }EXE{^ 
	VK_CANCEL 		0x03 Ctrl-Break 
	VK_MBUTTON 		0x04 }EX{^ 
	VK_BACK 		0x08 Backspace 
	VK_TAB 			0x09 Tab 
	VK_CLEAR 		0x0C NumLock OԂ̃eL[5 
	VK_RETURN 		0x0D Enter 
	VK_SHIFT 		0x10 Shift 
	VK_CONTROL 		0x11 Ctrl 
	VK_MENU 		0x12 Alt 
	VK_PAUSE 		0x13 Pause 
	VK_CAPITAL 		0x14 Caps Lock 
	VK_KANA 		0x15 
	VK_HANGEUL 
	VK_HANGUL VL_JUNJA 		0x17 
	VK_FINAL 		0x18 
	VK_HANJA 		0x19 
	VK_KANJI 
	VK_ESCAPE 		0x1B Esc 
	VK_CONVERT 		0x1C 
	VK_NONCONVERT 	0x1D 
	VK_ACCEPT 		0x1E 
	VK_MODECHANGE 	0x1F 
	VK_SPACE 		0x20 Spacebar 
	VK_PRIOR 		0x21 Page Up 
	VK_NEXT 		0x22 Page Down 
	VK_END 			0x23 End 
	VK_HOME 		0x24 Home 
	VK_LEFT 		0x25 L[ 
	VK_UP 			0x26 L[ 
	VK_RIGHT 		0x27 EL[ 
	VK_DOWN 		0x28 L[ 
	VK_SELECT 		0x29 
	VK_PRINT 		0x2A 
	VK_EXECUTE 		0x2B 
	VK_SNAPSHOT 	0x2C PringScreen 
	VK_INSERT 		0x2D Insert 
	VK_DELETE 		0x2E Delete 
	VK_HELP 		0x2F -- 0x30`0x39 CL[{[h 0`9 -- 0x41`0x5A L[ A  Z 
	VK_LWIN 		0x5B  Windows L[ 
	VK_RWIN 		0x5C E Windows L[ 
	VK_APPS 		0x5D AvP[VL[ 
	VK_NUMPAD0 		0x60 NumLock IɂȂĂԂłꂼeL[ 0 ` 9 ܂ 
	VK_NUMPAD1 		0x61 
	VK_NUMPAD2 		0x62 
	VK_NUMPAD3 		0x63 
	VK_NUMPAD4 		0x64 
	VK_NUMPAD5 		0x65 
	VK_NUMPAD6 		0x66 
	VK_NUMPAD7 		0x67 
	VK_NUMPAD8 		0x68 
	VK_NUMPAD9 		0x69 
	VK_MULTIPLY 	0x6A eL[ * 
	VK_ADD 			0x6B eL[ + 
	VK_SEPARATOR 	0x6C 
	VK_SUBTRACT 	0x6D eL[ - 
	VK_DECIMAL 		0x6E eL[ . 
	VK_DIVIDE 		0x6F eL[ / 
*/
//======================================
//		MOUSE							
//======================================
class MOUSE {
	POINT m_bef_pos, m_pos;
	char m_bef_stat[2], m_stat[2];
	public :
	// q_
	get_left(int bef_va_vail=1){
		if (bef_va_vail){
			if (!m_bef_stat[0] && m_stat[0]) return 1;
		}else {
			if (m_stat[0]) return 1;
		}
		return 0;
	}
	// ~M
	get_right(int bef_va_vail=1){
		if (bef_va_vail){
			if (!m_bef_stat[1] && m_stat[1]) return 1;
		}else {
			if (m_stat[1]) return 1;
		}
		return 0;
	}
	is_move(){
		return (m_bef_pos.x!=m_pos.x || m_bef_pos.y!=m_pos.y);
	}
	// ʒu
	POINT get_pos(){
		return m_pos;
	}
	// ԍXV
	update_stat(){
		// }EXԍXV
		m_bef_pos=m_pos;
		GetCursorPos(&m_pos);
		ScreenToClient(g_gv.m_hwnd, &m_pos);
		if (g_gv.m_win_size_mode!=GV::WIN_SIZE_DEFAULT && g_gv.m_win_size_mode!=GV::WIN_SIZE_FULL){
			m_pos.x = (g_gv.get_win_width() *m_pos.x/g_gv.m_win_in_size.cx);
			m_pos.y = (g_gv.get_win_height()*m_pos.y/g_gv.m_win_in_size.cy);
		}

		m_bef_stat[0]=m_stat[0];
		m_bef_stat[1]=m_stat[1];
		m_stat[0]=(GetKeyState(VK_LBUTTON)<0);
		m_stat[1]=(GetKeyState(VK_RBUTTON)<0);
		return 0;
	}
};
//======================================
//		INPUT							
//======================================
class INPUT {
	KEYBORD m_key;
	JOYSTICK **m_pp_joy;
	char m_cross_bef_stat[4],  m_cross_stat[4];
	char m_button_bef_stat[GV::GV_BUTTON_LEN], m_button_stat[GV::GV_BUTTON_LEN];
	public :
	INPUT(){ m_pp_joy=NULL; }
	set_joystick(JOYSTICK **pp_joy){
		m_pp_joy=pp_joy;
	}
	// ԍXV
	update_stat(){
		int i;
		// \L[ԍXV
		for(i=0;i<4;i++){
			m_cross_bef_stat[i] = m_cross_stat[i];
			m_cross_stat[i]=(GetKeyState(m_key.m_cross_code[i])<0);
		}
		// {^ԍXV
		for(i=0;i<GV::GV_BUTTON_LEN;i++){
			m_button_bef_stat[i] = m_button_stat[i];
			m_button_stat[i]=(GetKeyState(m_key.m_button_code[i])<0);
		}
		// WCXeBbN
		JOYSTICK *pjoy= (m_pp_joy)? pjoy=*m_pp_joy : NULL;
		if (pjoy) {
			pjoy->update_stat();
			for(i=0;i<4;i++) m_cross_stat[i] |= pjoy->get_cross_stat(i);
			for(i=0;i<GV::GV_BUTTON_LEN;i++)
				if (pjoy) m_button_stat[i] |= pjoy->get_button_stat(i);
		}

		return 0;
	}
	// \L[Ă邩
	get_any_cross(int bef_va_vail=1){
		if (get_side(bef_va_vail) || get_vert(bef_va_vail)) return 1;
		return 0;
	}
	// {^Ă邩
	get_decide_btn(int bef_va_vail=1){
		if (get_btn(0, bef_va_vail) || get_btn(2, bef_va_vail) || get_btn(4, bef_va_vail)) return 1;
		return 0;
	}
	// LZE{^Ă邩
	get_cancel_btn(int bef_va_vail=1){
		if (get_btn(1, bef_va_vail) || get_btn(3, bef_va_vail)) return 1;
		return 0;
	}
	// {^Ă邩
	get_any_btn(int bef_va_vail=1){
		int i;
		for(i=0;i<GV::GV_BUTTON_LEN;i++){
			if (get_btn(i, bef_va_vail)) return 1;
		}
		return 0;
	}
	// L[Ă邩
	get_any(int bef_va_vail=1){
		if (get_any_cross(bef_va_vail)) return 1;
		if (get_any_btn(bef_va_vail)) return 1;
		return 0;
	}
	// ̃{^Ă邩
	get_btn(int btn_num, int bef_va_vail=1){
		if (btn_num<0 || btn_num>=GV::GV_BUTTON_LEN) return 0;
		if (bef_va_vail){
			if (!m_button_bef_stat[btn_num] && m_button_stat[btn_num]) return 1;
		} else {
			if (m_button_stat[btn_num]) return 1;
		}
		return 0;
	}
	// ㉺L[Ă邩
	get_vert(int bef_va_vail=1){
		if (bef_va_vail){
			if		(!m_cross_bef_stat[GV::GV_UP]  && m_cross_stat[GV::GV_UP])  return -1;
			else if (!m_cross_bef_stat[GV::GV_DOWN] && m_cross_stat[GV::GV_DOWN]) return 1;
		} else {
			if		(m_cross_stat[GV::GV_UP])  return -1;
			else if (m_cross_stat[GV::GV_DOWN]) return 1;
		}
		return 0;
	};
	// EL[Ă邩
	get_side(int bef_va_vail=1){
		if (bef_va_vail){
			if		(!m_cross_bef_stat[GV::GV_LEFT]  && m_cross_stat[GV::GV_LEFT])  return -1;
			else if (!m_cross_bef_stat[GV::GV_RIGHT] && m_cross_stat[GV::GV_RIGHT]) return 1;
		} else {
			if		(m_cross_stat[GV::GV_LEFT])  return -1;
			else if (m_cross_stat[GV::GV_RIGHT]) return 1;
		}
		return 0;
	};
};

