
class DRAW_STOCK{
	public :
	DRAW_STOCK(){
		m_type=INVALIED;
		m_blend_flag=0;
	}
	enum { INVALIED, IMG_DRAW_TYPE, FILL_TYPE, BRUSH_FILL_TYPE, DRAW_TEXT_TYPE, SET_ALPHA_TYPE, ALPHA_PASTE_TYPE };
	enum { NO_BLEND, BLEND };
	char m_type;
	GDIB *m_dst_pdib, *m_src_pdib;
	int m_dx, m_dy, m_sx, m_sy, m_cx, m_cy, m_rate, m_blend_flag;
	char m_r, m_g, m_b, *m_str;
	HFONT m_hfont;
	HBRUSH m_hbr;
	set_draw_img(GDIB *d_pdib, int x, int y, GDIB *s_pdib, int sx, int sy, int cx, int cy, int rate, int blend_flag){
		m_type=IMG_DRAW_TYPE;
		m_dst_pdib = d_pdib;
		m_dx=x; m_dy=y; m_sx=sx; m_sy=sy; m_cx=cx; m_cy=cy; m_rate=rate; m_blend_flag=blend_flag;
		m_src_pdib = s_pdib;
		return 0;
	}
	set_fill(GDIB *d_pdib, int x, int y, int cx, int cy, char r, char g, char b, int rate){
		m_type=FILL_TYPE;
		m_dst_pdib = d_pdib;	m_dx=x; m_dy=y; m_cx=cx; m_cy=cy; m_rate=rate;
		m_r=r; m_g=g; m_b=b;
		return 0;
	}
	set_fill(GDIB *d_pdib, int x, int y, int cx, int cy, HBRUSH hbr){
		m_type=BRUSH_FILL_TYPE;
		m_dst_pdib = d_pdib;	m_dx=x; m_dy=y; m_cx=cx; m_cy=cy; m_hbr=hbr;
		return 0;
	}
	// eLXg
	set_draw_text(GDIB *d_pdib, char *s, int x, int y, HFONT hfont){
		m_type=DRAW_TEXT_TYPE;
		m_dst_pdib = d_pdib;	m_dx=x; m_dy=y;		m_hfont=hfont;
		m_str=s;
		return 0;
	}
	set_alpha(GDIB *d_pdib, int x, int y, int cx, int cy, int rate){
		m_type=SET_ALPHA_TYPE;
		m_dst_pdib = d_pdib;	m_dx=x; m_dy=y; m_cx=cx; m_cy=cy; m_rate=rate;
		return 0;
	}
	alpha_paste(GDIB *d_pdib, int x, int y, GDIB *s_pdib, int sx, int sy, int cx, int cy, int rate, int blend_flag){
		m_type=ALPHA_PASTE_TYPE;
		m_dst_pdib = d_pdib;
		m_dx=x; m_dy=y; m_sx=sx; m_sy=sy; m_cx=cx; m_cy=cy; m_rate=rate; m_blend_flag=blend_flag;
		m_src_pdib = s_pdib;
	}
	carry_out(){
		if (m_dst_pdib)
		switch(m_type){
		case ALPHA_PASTE_TYPE:
			m_dst_pdib->from_alpha_paste(m_dx,m_dy, m_src_pdib, m_sx, m_sy, m_cx, m_cy, m_rate, m_blend_flag);
			break;
		case IMG_DRAW_TYPE: 
			m_dst_pdib->from_draw(m_dx,m_dy, m_src_pdib, m_sx, m_sy, m_cx, m_cy, m_rate, m_blend_flag);
			break;
		case BRUSH_FILL_TYPE:
			fill(m_dst_pdib->m_hdc, m_dx, m_dy, m_cx, m_cy, m_hbr);
			break;
		case FILL_TYPE:
			m_dst_pdib->fill(m_dx, m_dy, m_cx, m_cy, m_r, m_g, m_b, m_rate);
			break;
		case SET_ALPHA_TYPE:
			m_dst_pdib->set_alpha(m_dx, m_dy, m_cx, m_cy, m_rate);
			break;
		case DRAW_TEXT_TYPE:
			SelectObject(m_dst_pdib->m_hdc, m_hfont);
			TextOut(m_dst_pdib->m_hdc, m_dx, m_dy, m_str, strlen(m_str));
			break;
		}
		m_type=INVALIED;
		return 0;
	}
};

class SCREEN {
	int m_draw_stock_len;
	enum{ DRAW_STOCK_MAX=300 };
	DRAW_STOCK m_draw_stock[DRAW_STOCK_MAX];
	GDIB m_main_img, m_back_img, m_work_img;
	public :
	char m_back_prepare[GV::GV_WIN_BASE_LEN*GV::GV_WIN_BASE_LEN*4];
	SCREEN(){
		m_draw_stock_len=0;
	}
	~SCREEN(){
	}
	carry_out_draw(){
		carry_out_reback();
		for(int i=0;i<m_draw_stock_len;i++){
			m_draw_stock[i].carry_out();
		}
		m_draw_stock_len=0;
	}
	get_width(){ return m_main_img.m_width; };
	get_height(){ return m_main_img.m_height; };
	make(int x, int y){
		m_main_img.make(x, y, 16, 0);
		m_work_img.make(x, y, 16, 0);
		m_back_img.make(x, y, 16, 0);
		memset(m_back_prepare, 0, GV::GV_WIN_BASE_LEN*GV::GV_WIN_BASE_LEN*4);
	}
	prepare_reback(int x, int y, int cx, int cy){
		int bx=GV::GV_BX/2, by=GV::GV_BY/2;
		int ix, iy, xlen, ylen, pix_cx=m_main_img.m_width/bx;

		// }CiXW̕␳
		if (x<0){ cx+= x; x=0; };
		if (y<0){ cy+= y; y=0; };
		// ERs[̕␳
		if ((x+cx)>get_width())	{ cx=get_width() -x;};
		if ((y+cy)>get_height()){ cy=get_height()-y;};

		xlen=(x+cx)/bx+(bool)((x+cx)%bx);
		ylen=(y+cy)/by+(bool)((y+cy)%by);
		for(iy=y/by;iy<ylen;iy++){
			for(ix=x/bx;ix<xlen;ix++){
				m_back_prepare[iy*pix_cx+ix]=1;
			}
		}
	}
	carry_out_reback(){
		int bx=GV::GV_BX/2, by=GV::GV_BY/2;
		int ix, iy, xlen=m_main_img.m_width/bx, ylen=m_main_img.m_height/by, pix_cx=m_main_img.m_width/bx;
		for(iy=0;iy<ylen;iy++){
			for(ix=0;ix<xlen;ix++){
				if (m_back_prepare[iy*pix_cx+ix]){
					BitBlt(m_main_img.m_hdc, ix*bx,iy*by, GV::GV_BX/2, GV::GV_BY/2, m_back_img.m_hdc, ix*bx,iy*by, SRCCOPY);
				};
			}
		}
		memset(m_back_prepare, 0, GV::GV_WIN_BASE_LEN*GV::GV_WIN_BASE_LEN*4);
		return GV::GV_OK;
	}
	fill_main(int x, int y, int cx, int cy, HBRUSH hbr){
		if (m_draw_stock_len<DRAW_STOCK_MAX){
			m_draw_stock[m_draw_stock_len].set_fill(&m_main_img, x,y, cx, cy, hbr);
			m_draw_stock_len++;
		}
		return GV::GV_OK;
	}
	fill_main(int x, int y, int cx, int cy, char r, char g, char b, int rate){
		if (m_draw_stock_len<DRAW_STOCK_MAX){
			m_draw_stock[m_draw_stock_len].set_fill(&m_main_img, x,y, cx, cy, r, g, b, rate);
			m_draw_stock_len++;
		}
		return GV::GV_OK;
	}
	fill_back(int x, int y, int cx, int cy, HBRUSH hbr){
		if (m_draw_stock_len<DRAW_STOCK_MAX){
			m_draw_stock[m_draw_stock_len].set_fill(&m_back_img, x,y, cx, cy, hbr);
			m_draw_stock_len++;
		}
		return GV::GV_OK;
	}
	fill_work(int x, int y, int cx, int cy, HBRUSH hbr){
		if (m_draw_stock_len<DRAW_STOCK_MAX){
			m_draw_stock[m_draw_stock_len].set_fill(&m_work_img, x,y, cx, cy, hbr);
			m_draw_stock_len++;
		}
		return GV::GV_OK;
	}
	fill_work(int x, int y, int cx, int cy, char r, char g, char b, int rate){
		if (m_draw_stock_len<DRAW_STOCK_MAX){
			m_draw_stock[m_draw_stock_len].set_fill(&m_work_img, x,y, cx, cy, r, g, b, rate);
			m_draw_stock_len++;
		}
		return GV::GV_OK;
	}
	//====` x̑=====================
	set_alpha_work(int x, int y, int cx, int cy, int rate){
		if (m_draw_stock_len<DRAW_STOCK_MAX){
			m_draw_stock[m_draw_stock_len].set_alpha(&m_work_img, x,y, cx, cy, rate);
			m_draw_stock_len++;
		}
		return GV::GV_OK;
	}
	alpha_paste_to_work(int x, int y, GDIB *pdib, int src_x, int src_y, int cx, int cy, int rate, int blend_flag){
		if (m_draw_stock_len<DRAW_STOCK_MAX){
			m_draw_stock[m_draw_stock_len].alpha_paste(&m_work_img, x,y, pdib, src_x, src_y, cx, cy, rate, blend_flag);
			m_draw_stock_len++;
		}
		return GV::GV_OK;
	}
	//====ɉ摜`=====================
	// 摜`
	img_draw_direct(int x, int y, GDIB *pdib, int src_x, int src_y, int cx, int cy, int rate, int blend_flag){
		return m_main_img.from_draw(x, y, pdib, src_x, src_y, cx, cy, rate, blend_flag);
	}
	img_copy_direct(int x, int y, GDIB *pdib, int src_x, int src_y, int cx, int cy, int rate, int blend_flag){
		return pdib->from_draw(x, y, &m_main_img, src_x, src_y, cx, cy, rate, blend_flag);
	}
	img_draw(int x, int y, GDIB *pdib, int src_x, int src_y, int cx, int cy, int rate, int blend_flag){
		return to_screen_draw(&m_main_img, x, y, pdib, src_x, src_y, cx, cy, rate, blend_flag);
	}
	// wiɕ`
	to_back_draw(int x, int y, GDIB *pdib, int src_x, int src_y, int cx, int cy, int rate, int blend_flag){
		return to_screen_draw(&m_back_img, x, y, pdib, src_x, src_y, cx, cy, rate, blend_flag);
	}
	// [Ncbɕ`
	to_work_draw(int x, int y, GDIB *pdib, int src_x, int src_y, int cx, int cy, int rate, int blend_flag){
		return to_screen_draw(&m_work_img, x, y, pdib, src_x, src_y, cx, cy, rate, blend_flag);
	}
	// XN[`
	to_screen_draw(GDIB *p_src_dib, int dx, int dy, GDIB *pdib, int sx, int sy, int cx, int cy, int rate, int blend_flag){
		if (!pdib || !pdib->m_hdc) return GV::GV_NG;
		if (m_draw_stock_len<DRAW_STOCK_MAX){
			m_draw_stock[m_draw_stock_len].set_draw_img(p_src_dib, dx,dy, pdib, sx, sy, cx, cy, rate, blend_flag);
			m_draw_stock_len++;
		}
		return GV::GV_OK;
	}
	//==== `=====================
	// wi烁Cʂɕ`
	reback_draw(int x, int y, int cx, int cy, int rate, int blend_flag){
		prepare_reback(x, y, cx, cy);
		return GV::GV_OK;
	}
	// [Ncb烁Cʂɕ`
	rework_draw(int x, int y, int cx, int cy, int rate, int blend_flag){
		if (m_draw_stock_len<DRAW_STOCK_MAX){
			m_draw_stock[m_draw_stock_len].set_draw_img(&m_main_img, x,y, &m_work_img, x, y, cx, cy, rate, blend_flag);
			m_draw_stock_len++;
		}
		return GV::GV_OK;
	}
	// Cʂwi
	main_to_back_draw(int x, int y, int cx, int cy){
		if (m_draw_stock_len<DRAW_STOCK_MAX){
			m_draw_stock[m_draw_stock_len].set_draw_img(&m_back_img, x,y, &m_main_img, x, y, cx, cy, 255, 1);
			m_draw_stock_len++;
		}
		return GV::GV_OK;
	}
	// Cʂ烏[Ncbɕ`
	main_to_work_draw(int x, int y, int cx, int cy, int rate){
		if (m_draw_stock_len<DRAW_STOCK_MAX){
			m_draw_stock[m_draw_stock_len].set_draw_img(&m_work_img, x,y, &m_main_img, x, y, cx, cy, rate, 1);
			m_draw_stock_len++;
		}
		return GV::GV_OK;
	}
	HDC get_main_dc(){ return m_main_img.m_hdc; };
	HDC get_work_dc(){ return m_work_img.m_hdc; };
	HDC get_back_dc(){ return m_back_img.m_hdc; };

	// DC
	stand_dc(HWND hwnd){
		m_main_img.stand_dc(hwnd);
		m_work_img.stand_dc(hwnd);
		m_back_img.stand_dc(hwnd);
		return GV::GV_OK;
	}
	load_back(char *filename){
		GDIB gdib;
		gdib.load(filename);
		gdib.stand_dc(m_back_img.m_hdc);
		BitBlt(m_back_img.m_hdc, 0,0, gdib.m_width, gdib.m_height, gdib.m_hdc, 0,0, SRCCOPY);
		BitBlt(m_main_img.m_hdc, 0,0, gdib.m_width, gdib.m_height, gdib.m_hdc, 0,0, SRCCOPY);
		return GV::GV_OK;
	};
	//=========================
	SIZE get_str_size(char *s){	return ::get_str_size(get_main_dc(), s);	}
	get_font_height(){ return ::get_font_height(get_main_dc()); }

	select_font(HFONT hfont){
		SelectObject(m_main_img.m_hdc, hfont);
		SelectObject(m_work_img.m_hdc, hfont);
		SelectObject(m_back_img.m_hdc, hfont);
		return GV::GV_OK;
	}
	set_bg_mode(int mode){
		SetBkMode(m_main_img.m_hdc, mode);
		SetBkMode(m_work_img.m_hdc, mode);
		SetBkMode(m_back_img.m_hdc, mode);
		return GV::GV_OK;
	}
	set_text_color(COLORREF text_col, COLORREF back_col){
		SetTextColor(m_main_img.m_hdc, text_col);	SetBkColor(m_main_img.m_hdc, back_col);
		SetTextColor(m_work_img.m_hdc, text_col);	SetBkColor(m_work_img.m_hdc, back_col);
		SetTextColor(m_back_img.m_hdc, text_col);	SetBkColor(m_back_img.m_hdc, back_col);
		return GV::GV_OK;
	};
	draw_text(HFONT hfont, char *s, int x, int y, int align, int v_align, int rate);
};
// eLXg`
SCREEN::draw_text(HFONT hfont, char *s, int x, int y, int align, int v_align, int rate){
	if (!s) return 0;
	if (align!=GV::GV_LEFT){
		SIZE size=get_str_size(s);
		if (align==GV::GV_CENTER) x-=(size.cx/2);
		else if (align==GV::GV_RIGHT) x-=size.cx;
	}
	if (v_align!=GV::GV_TOP){
		if (v_align==GV::GV_CENTER) y-=(get_font_height()/2);
		else if (v_align==GV::GV_BOTTOM) y-=get_font_height();
	}

	if (m_draw_stock_len<DRAW_STOCK_MAX){
		m_draw_stock[m_draw_stock_len].set_draw_text(&m_main_img, s, x,y, hfont);
		m_draw_stock_len++;
	}
	return GV::GV_OK;
	/*
	if (rate>=255) TextOut(get_main_dc(), x, y, s, strlen(s));
	else {
		SIZE size;
		GetTextExtentPoint32(get_main_dc(), s, strlen(s), &size);
		BitBlt(get_work_dc(), x, y, size.cx, size.cy, get_main_dc(), x, y, SRCCOPY);
		TextOut(get_work_dc(), x, y, s, strlen(s));
		rework_draw(x, y, size.cx, size.cy, rate, 0);
	}
	*/
	return GV::GV_OK;
}
